//variable qui stocke l'input de l'audio
var mic;

//variables concernant les couleurs
var r;
var g;
var b;
var colorDistance=20;
var minBrightness=75;

//variable de display
var minDisplaySize;

//variable qui stocke les vagues,son couleur et son temps d'apparition
var waves=[];

//variable de scaling pour le volume
var scaleVol=0.995;

//variable d'easing
var easing=0.92;

//variable qui stocke le volume max lors de la configuration du micro
var vMax=0;

//valeur compris entre 0 et 1 porportionnel au volume;
var lastValue=0;

//variable qui dit détermine 3 états: 0->micro non configuré,0.5->configuration de micro,1->micro configuré
var micSetted=0;

//variable qui stocke le temps de configuration
var t;

//variable concernant le threshold pour la génération des vagues.
var minVolumeDraw=0.2;

//variable de scaling concernant la mort des vagues
var scaleDeath=1;

//la durée maximale de la vie d'une vague
var maxDuration=7000;

//variables de temps qui permet de créer un intervalle entre deux vagues. Chaque vague est crée après chaque stepTime. Temps en ms.
var lastTime=0;
var stepTime=75;

//variable stockant le manche courant
var currentRound=0;

//le nombre maximum de manche
var maxRound=5;

//variable stockant les points qui sont la cummulation du rayon max atteint à chaque manche
var p=new gamePoint();

//variable qui définit si une manche est terminé
var currentRoundFinish=false;

//listes de rayons à atteindre pour chaque jeu.
var listRayon=[];
var listRayon2=[];

//variable pour le niveau courant
var currentLevel=1;

//variable pour la fin du niveau courant
var currentLevelFinish=false;

//variable pour savoir le temps de finition d'un niveau
var levelFinishTime=-1;

//variable pour régler la difficulté des manches
var scaleDiff=1.2;
var scaleDiff2=0.99;

//fonction permettant de configuér le micro
function setMic() {
  t=millis()+5000;
  micSetted=0.5;
  fill(0, 255, 0);
}

//function setup
function setup() {
  //display
  createCanvas(displayWidth, displayHeight);//création du window
  minDisplaySize=min(width, height);

  //micro
  mic=new p5.AudioIn();
  smooth();
  mic.start();

  //cercle
  ellipseMode(CENTER);
  strokeWeight(4*sqrt(stepTime));
  fill(255, 0, 0);

  //text
  textSize(80);
  textAlign(CENTER);

  //color
  r=random(255);
  g=random(255);
  b=random(255);
}

//appuyer sur le boutton du souris pour configurer le micro
function mousePressed() {
  if (micSetted==0)
    setMic();
}

//créer un couleur aléatoire pour une vague
function generateColor() {
  //calcul du couleur en partant d'un couleur initial vers unautre avec couleurDistance
  r=(r+random(2*colorDistance)-colorDistance+255)%255;
  g=(g+random(2*colorDistance)-colorDistance+255)%255;
  b=(b+random(2*colorDistance)-colorDistance+255)%255;

  //brightness approximative
  var brightness=(r+g+b)/3;

  //augmente brightness s'il le faut
  if (brightness<minBrightness) {
    r*=minBrightness/brightness;
    g*=minBrightness/brightness;
    b*=minBrightness/brightness;
  }
}

//créer une vague et le met dans waves
function generateWave() {
  var value=mic.getLevel()/vMax;
  lastValue=max(value, lastValue*easing);
  waves.push([lastValue, millis(), r, g, b]);
  if (waves[waves.length-1][0]>minVolumeDraw) {
    generateColor();
  }
}

//fonction qui dessine les vagues.
function displayWaves() {
  for (var k=0; k<waves.length; k++) {
    waves[k][0]*=scaleVol;
    if (waves[k][0]>minVolumeDraw) {
      var rayon=(millis()-waves[k][1])*minDisplaySize/maxDuration;
      stroke(waves[k][2], waves[k][3], waves[k][4], 255*(waves[k][0]-minVolumeDraw)/(1-minVolumeDraw));
      ellipse(width/2, height/2, rayon, rayon);
      if (currentLevel==1) {
        if (roundFinished(rayon, currentLevel) && !(currentRoundFinish) ) {
          currentRoundFinish=true;
          currentRound+=1;
          p.add((int)(rayon));
        }
      } else {
        if (roundFinished(rayon, currentLevel) && !(currentRoundFinish) ) {
          if (waves[k][0]*scaleVol<scaleDeath*minVolumeDraw ) {
            currentRoundFinish=true;
            currentRound+=1;
            p.add((int)(rayon));
          }
        }
      }
      if (waves[k][0]<scaleDeath*minVolumeDraw || (millis()-waves[k][1])>maxDuration||currentRoundFinish) {
        waves.splice(k, 1);
      }
    }
  }
}
//class point
function gamePoint() {
  this.point=0;
  this.add=function(p) {
    this.point+=p;
  }
  this.display=function() {
    text(this.point, width/2, height/3);
  }
}


//fonction qui créé le jeu avec un nombre round de manche par niveau pour un niveau level donné.
function createGame(round, level) {
  switch(level) {
  case 1:
    this.rayon=random(300, 400);
    listRayon.push(this.rayon);
    for (var i=1; i<round; i++) {
      listRayon.push(this.rayon*pow(scaleDiff, i));
    }

  case 2:
    this.rayon1=random(300, 400);
    this.rayon2=this.rayon + 600;
    listRayon.push(this.rayon1);
    listRayon2.push(this.rayon2);
    for (var i=1; i<round; i++) {
      listRayon.push(this.rayon1*pow(scaleDiff, i));
      listRayon2.push(this.rayon2*pow(scaleDiff2, i));
    }
  }
  console.log(listRayon);
  console.log(listRayon2);
}

//fonction qui dit si une manche est terminée avec comme paramètre rayon et niveau
function roundFinished(rayon, level) {
  switch(level) {
  case 1:
    if (rayon>=listRayon[currentRound]) {
      return true;
    }
    return false;
  case 2:
    if (rayon>=listRayon[currentRound] && rayon<listRayon2[currentRound]) {      
      return true;
    }
    return false;
  }
}

function changeLevel() {
  if (currentLevelFinish) {
    if (millis()>levelFinishTime + 5000) {
      currentLevel+=1
        currentLevelFinish=false;
    }
  }
}

//function draw
function draw() {
  background(0);

  if (micSetted==1) {
    createGame(maxRound, currentLevel);
    if (currentLevel==1 ) {      
      if (currentRound <maxRound && !(currentLevelFinish)) {  
        strokeWeight(4);
        stroke(0, 255, 0);
        text("Reach further than the target circle with your voice", width/2, 65);
        strokeWeight(3);
        stroke(255, 0, 0);
        ellipse(width/2, height/2, listRayon[currentRound], listRayon[currentRound]);
        strokeWeight(4*sqrt(stepTime));

        if (currentRoundFinish) {
          if (millis()>lastTime+10*stepTime) {
            currentRoundFinish=false;
            generateWave();
            lastTime=millis()+stepTime;
          }
        } else {
          if (millis()>lastTime) {
            generateWave();
            lastTime=millis()+stepTime;
          }
        }
        displayWaves();
      } else {
        strokeWeight(4);
        stroke(0, 255, 0);
        text("You win Round 1", width/2, height/2);
        p.display();
        currentLevelFinish=true;
        if (levelFinishTime<0)  levelFinishTime=millis();
        changeLevel();
        currentRound=0;
        waves.splice(0, waves.length);
      }
    } else {
      console.log(currentRound);
      if (currentRound<maxRound) {
        strokeWeight(4);
        stroke(0, 255, 0);
        text("Stay between both circles", width/2, 65);
        strokeWeight(3);
        stroke(255, 0, 0);
        ellipse(width/2, height/2, listRayon[currentRound], listRayon[currentRound]);
        ellipse(width/2, height/2, listRayon2[currentRound], listRayon2[currentRound]);
        strokeWeight(4*sqrt(stepTime));
        if (currentRoundFinish) {
          if (millis()>lastTime+10*stepTime) {
            currentRoundFinish=false;
            generateWave();
            lastTime=millis()+stepTime;
          }
        } else {
          if (millis()>lastTime) {
            generateWave();
            lastTime=millis()+stepTime;
          }
        }
        displayWaves();
      } else {
        strokeWeight(4);
        stroke(0, 255, 0);
        text("You win Round 2", width/2, height/2);
        p.display();
      }
    }
  } else if (micSetted==0) {
    text("Microphone not configurated: press any mouse button", width/2, height/2);
  } else {
    vMax=max(vMax, mic.getLevel());
    var vdisp=(int)(vMax*100);//volume de display contenu entre 0 et 100
    text(vdisp.toString(), width/2, height/1.3);
    var tdisp=(int)((t-millis())/100)/10;//temps de display contenu entre 0 et t;
    text(tdisp.toString(), width/2, height/2);
    if (t<millis()) {
      micSetted=1;
      noFill();
    }
  }
}